module IOExts
  ( IORef
  , newIORef
  , readIORef
  , writeIORef
  , unsafePerformIO
  , unsafeInterleaveIO
  )
 where

-- IOExts for Hbc

import UnsafePerformIO
  ( unsafePerformIO
  )

import IOMutVar
  ( MutableVar
  , newVar
  , readVar
  , writeVar
  , sameVar
  )

newtype IORef a = IORef (MutableVar a)

instance Eq (IORef a) where
  IORef var1 == IORef var2 = sameVar var1 var2

newIORef :: a -> IO (IORef a)
newIORef a =
  do var <- newVar a
     return (IORef var)

readIORef :: IORef a -> IO a
readIORef (IORef var) =
  do readVar var

writeIORef :: IORef a -> a -> IO ()
writeIORef (IORef var) a =
  do writeVar var a

unsafeInterleaveIO :: IO a -> IO a
unsafeInterleaveIO io = return (unsafePerformIO io)
