module LavaRandom
  ( Rnd
  , newRnd
  , next
  , split
  )
 where

import RandomHBC
  ( normalRandomDoubles
  )

import IOExts
  ( unsafePerformIO
  , IORef
  , newIORef
  , readIORef
  , writeIORef
  )

data Rnd
  = Split Int Rnd Rnd

globalRndVar :: IORef Int
globalRndVar = unsafePerformIO (newIORef 0)

newRnd :: IO Rnd
newRnd =
  do n <- readIORef globalRndVar
     writeIORef globalRndVar (n+1)
     return (makeRnd n)

makeRnd :: Int -> Rnd
makeRnd n = Split i (makeRnd (n1 + n - 7)) (makeRnd (n2 - n + 13))
 where
  (i : n1 : n2 : _) = map round (normalRandomDoubles n (2 * n + 17))

next :: Rnd -> (Int, Rnd)
next (Split n rnd _) = (n, rnd)

split :: Rnd -> (Rnd, Rnd)
split (Split _ rnd1 rnd2) = (rnd1, rnd2)

